indexing

	description: "[

		Implements the main EiffelMedia AUDIO_MIXER applicaton.
		
		This class initialize the video- and audio-subsystem and it starts the MIXER_SCENE.

	]"
	date: "$Date: 2005/10/28 07:48:17 $"
	revision: "$Revision: 1.13 $"

class AUDIO_MIXER

inherit

	MIXER_CONSTANTS
		export {NONE} all end

	EM_APPLICATION
		export {NONE} all end

	EM_SHARED_SUBSYSTEMS
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		do
			create keyboard.make_snapshot
			keyboard.enable_unicode_characters
			keyboard.enable_repeating_key_down_events (200, 100)

			-- Initialize screen
			video_subsystem.set_video_surface_width (window_width)
			video_subsystem.set_video_surface_height (window_height)
			video_subsystem.set_video_bpp (resolution)
			video_subsystem.set_fullscreen (fullscreen)
			video_subsystem.set_software_surface (True)
			initialize_screen

			set_window_icon ("icon.png")
			set_window_title ("Audio Mixer")
			set_application_id ("audio_mixer")

			-- Initialize audio
			audio_subsystem.enable
			if audio_subsystem.is_enabled then
				set_scene (create {MIXER_SCENE}.make)
				launch
			end

			audio_subsystem.disable
			video_subsystem.disable
		end

feature -- Access

	keyboard: EM_KEYBOARD

end
