indexing

	description: "[

		This class holds all the audio_mixer constants.
		
		Use this constants for setting up audio_mixer environment.

	]"
	date: "$Date: 2005/10/23 11:06:03 $"
	revision: "$Revision: 1.8 $"

class MIXER_CONSTANTS

inherit

	KL_SHARED_FILE_SYSTEM
		export {NONE} all end

	KL_SHARED_EXECUTION_ENVIRONMENT
		export {NONE} all end

feature -- Constants

	window_width: INTEGER is 1024
		-- Default window width

	window_height: INTEGER is 768
		-- Default window height

	resolution: INTEGER is 32
		-- Default resolution

	fullscreen: BOOLEAN is False
		-- Default fullscreen is disabled

	music_directory: STRING is
			-- Directory for music files
		once
			Result := file_system.pathname_from_file_system ("$EM/example/resources/music", unix_file_system)
			Result := execution_environment.interpreted_string (Result)
			if not file_system.directory_exists (Result) then
				Result := "music"
			end
		end

	sound_directory: STRING is
			-- Directory for sound files.
		once
			Result := file_system.pathname_from_file_system ("$EM/example/resources/sound", unix_file_system)
			Result := execution_environment.interpreted_string (Result)
			if not file_system.directory_exists (Result) then
				Result := "sound"
			end
		end

	image_directory: STRING is "image"
		-- Directory for images

end