indexing

	description: "[

		EiffelMedia CD_PLAYER application. Demonstration of the CDRom_Subsystem.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.9 $"

class CDPLAYER

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

	EM_SHARED_WIDGET_OPTIONS
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- Initialise screen
			video_subsystem.set_video_surface_width (window_width)
			video_subsystem.set_video_surface_height (window_height)
			video_subsystem.set_video_bpp (screen_resolution)
			video_subsystem.set_fullscreen (fullscreen)
			video_subsystem.enable
			cdrom_subsystem.enable
			initialize_screen

			-- Enable unicode characters and repeating keyboard events
			create keyboard.make_snapshot
			keyboard.enable_unicode_characters
			keyboard.enable_repeating_key_down_events (200, 100)

			set_window_title ("Eiffel Media CD-Player")
			set_application_id ("cdplayer_example")

			-- Set widget theme and options
			widget_options.disable_transparency_refresh
			load_eclipse_theme

			set_scene (create {CDPLAYER_SCENE}.make)
			launch

			-- disable everything we have enabled
			-- this prevent some possible memory leakes in the OS
			cdrom_subsystem.disable
			video_subsystem.disable
		end

feature {NONE} -- Implementation

	window_width: INTEGER is 400
			-- Window width

	window_height: INTEGER is 200
			-- Window height

	screen_resolution: INTEGER is 32
			-- Screen resolution

	fullscreen: BOOLEAN is false
			-- Fullscreen?

end