indexing

	description: "[

		EiffelMedia example showing the use of some EM_DRAWABLE classes.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.7 $"

class DRAWABLE_APPLICATION

inherit

	EM_APPLICATION

create

	make

feature {NONE} -- Initialization

	make is
			-- Start main application.
		do
			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (Window_width)
			Video_subsystem.set_video_surface_height (Window_height)
			Video_subsystem.set_video_bpp (Screen_resolution)
			Video_subsystem.set_fullscreen (Is_fullscreen_enabled)
			Video_subsystem.enable
			initialize_screen

			-- Check subsystem initialisation
			if Video_subsystem.is_enabled then

				-- Set global options
				set_window_title ("EiffelMedia drawable")
				set_window_icon ("icon.png")
				set_application_id ("drawable_example")

				-- Set first scene and launch it
				set_scene (create {FIRST_SCENE}.make_scene)

				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				io.error.put_string ("Unable to initialise video subsystem.%N")
			end
		end

feature {NONE} -- Implementation

	Window_width: INTEGER is 1024
			-- Window width

	Window_height: INTEGER is 768
			-- Window height

	Screen_resolution: INTEGER is 32
			-- Screen resolution

	Is_fullscreen_enabled: BOOLEAN is False
			-- Is fullscreen enabled?

end