indexing

	description: "[

		Hello 3d world example. Uses openGL to display a pyramid.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.7 $"

class HELLO_3D_WORLD

inherit

	EM_APPLICATION

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		do
			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (Window_width)
			Video_subsystem.set_video_surface_height (Window_height)
			Video_subsystem.set_video_bpp (Screen_resolution)
			Video_subsystem.set_fullscreen (Is_fullscreen_enabled)
			Video_subsystem.set_opengl (Is_opengl_enabled)
			Video_subsystem.enable
			initialize_screen

			-- Check subsystem initialisation
			if Video_subsystem.is_enabled then

				-- Set global options
				set_window_icon ("icon.png")
				set_window_title ("EiffelMedia hello 3d world")
				set_application_id ("hello_3d_world")

				-- Set first scene and launch it
				set_scene (create {FIRST_SCENE}.make)

				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				io.error.put_string ("Unable to initialise video subsystem.%N")
			end
		end

feature {NONE} -- Implementation

	Window_width: INTEGER is 1024
			-- Window width

	Window_height: INTEGER is 768
			-- Window height

	Screen_resolution: INTEGER is 24
			-- Screen resolution

	Is_fullscreen_enabled: BOOLEAN is False
			-- Is fullscreen enabled?

	Is_opengl_enabled: BOOLEAN is True
			-- Is OpenGL enabled?

end