indexing

	description: "[

		EiffelMedia HELLO_WORLD application. Displays an image.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.6 $"

class HELLO_WORLD

inherit

	EM_APPLICATION

	EM_SHARED_BITMAP_FACTORY
		export {NONE} all end

	EM_SHARED_ERROR_HANDLER
		export {NONE} all end

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		local
			first_scene: EM_DRAWABLE_SCENE
		do
			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (Window_width)
			Video_subsystem.set_video_surface_height (Window_height)
			Video_subsystem.set_video_bpp (Screen_resolution)
			Video_subsystem.set_fullscreen (Is_fullscreen_enabled)
			Video_subsystem.set_opengl (Is_opengl_enabled)
			Video_subsystem.enable

			initialize_screen

			-- Check subsystem initialisation
			if Video_subsystem.is_enabled then

				-- Set global options
				set_window_icon ("icon.png")
				set_window_title ("EiffelMedia hello_world")
				set_application_id ("hello_world")

				-- Setup first scene
				create first_scene.make_scene
				Bitmap_factory.create_bitmap_from_image (image_file_name)
				image := Bitmap_factory.last_bitmap
				first_scene.main_container.extend (image)

				-- Set first scene and launch it
				set_scene (first_scene)
				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				io.error.put_string ("Failed to initialise video subsystem.%N")
			end
		end

feature {NONE} -- Implementation

	image: EM_BITMAP
		-- Image bitmap

	image_file_name: STRING is "hello_world.gif"
		-- Name of image we want to display

	Window_width: INTEGER is 283
			-- Window width

	Window_height: INTEGER is 274
			-- Window height

	Screen_resolution: INTEGER is 16
			-- Screen resolution

	Is_fullscreen_enabled: BOOLEAN is False
			-- Is fullscreen enabled?

	Is_opengl_enabled: BOOLEAN is False
			-- Is OpenGL enabled?

end