indexing

	description: "[

		RACING_3D. EiffelMedia application.
		A simple racing game.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.6 $"

class RACING_3D

inherit

	EM_APPLICATION

create

	make

feature {NONE} -- Initialization

	make is
			-- Create the main application.
		do
			-- Initiliase subsystems
			Video_subsystem.set_video_surface_width (Window_width)
			Video_subsystem.set_video_surface_height (Window_height)
			Video_subsystem.set_video_bpp (Screen_resolution)
			Video_subsystem.set_fullscreen (Is_fullscreen_enabled)
			Video_subsystem.set_opengl (Is_opengl_enabled)
			Video_subsystem.enable

			initialize_screen

			if Video_subsystem.is_enabled then

				-- Set global options
				set_window_title ("EiffelMedia: Racing 3D")
				set_window_icon ("icon.png")
				set_application_id ("racing_3d")

				-- Tell the screen to automatically activate OpenGL blitting
				-- This is only needed if you don't want to handle it yourself
				-- It is not the most performing way, but the simplest.
				screen.enable_auto_opengl_blitting

				-- Set first scene and launch it
				set_scene (create {START}.make_scene)

				launch

				-- Disable subsystems
				Video_subsystem.disable
			else
				io.error.put_string ("Failed to initialise video subsystem.%N")
			end
		end

feature {NONE} -- Implementation

	Window_width: INTEGER is 1024
			-- Window width

	Window_height: INTEGER is 768
			-- Window height

	Screen_resolution: INTEGER is 32
			-- Screen resolution

	Is_fullscreen_enabled: BOOLEAN is False
			-- Is fullscreen enabled?

	Is_opengl_enabled: BOOLEAN is True
			-- Is OpenGL enabled?

end