indexing

	description: "[

		EiffelMedia AUDIO example. Plays a sound file using SDL_mixer.

	]"
	date: "$Date: 2005/10/24 17:10:54 $"
	revision: "$Revision: 1.8 $"

class SOUND

inherit

	EM_SHARED_SUBSYSTEMS
		export {NONE} all end

	EM_AUDIO_CONSTANTS
		export {NONE} all end

	KL_SHARED_FILE_SYSTEM
		export {NONE} all end

	KL_SHARED_EXECUTION_ENVIRONMENT
		export {NONE} all end

create

	make

feature -- Initialization

	make is
			-- This example shows how to simply play music.
			-- As there is nothing else using CPU resources,
			-- this example shows how to set better values as
			-- standard ones.
		local
			player: EM_MUSIC_PLAYER
		do
			-- Initialize audio subsystem
			audio_subsystem.enable
			if audio_subsystem.is_enabled then

				-- Open mixer with a frequency of 44.1 kHz
				audio_subsystem.mixer.open (44100, Em_audio_format_s16sys, Em_stereo, Em_default_chunk_size)

				-- Initialize musicplayer with one single file
				create player.make_with_file (file_system.pathname (Music_directory, "wish_you_were_here.ogg"), false)
				player.set_repeat (true)
				player.play

				-- Prevent window from closing
				io.put_string ("You should now hear some music playing! Press Return to quit!%N")
				io.read_line

				-- Free up resources
				audio_subsystem.disable
			else
				io.put_string ("Audio subsystem could not be enabled!%N")
			end
		end

feature {NONE} -- Implementation

	Music_directory: STRING is
			-- Music directory
		once
			Result := file_system.pathname_from_file_system ("$EM/example/resources/music", unix_file_system)
			Result := execution_environment.interpreted_string (Result)
			if not file_system.directory_exists (Result) then
				Result := "."
			end
		end

end
