indexing

	description: "[

		This class represents the widget where the SDL surface are drawn.
		Handle this class exactly like if it were inherited from EM_APPLICATION.
		Demonstration of the EiffelMedia Vision2 Widget (EM_EV_WIDGET) Capabilities.

	]"
	date: "$Date: 2005/10/26 18:07:42 $"
	revision: "$Revision: 1.6 $"

class VISION_WIDGET

inherit

	EM_EV_WIDGET_SCROLLABLE
		redefine
			make_em_application
		end

	EM_SHARED_WIDGET_OPTIONS
		export {NONE} all
		undefine
			default_create,
			copy
		end

create

	make

feature {NONE} -- Initialization

	make_em_application is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do
			-- Initialise screen
			video_subsystem.set_video_surface_width (window_width)
			video_subsystem.set_video_surface_height (window_height)
			video_subsystem.set_video_bpp (screen_resolution)
			video_subsystem.set_fullscreen (fullscreen)
			video_subsystem.set_opengl (true)
			video_subsystem.enable
			initialize_screen

			-- Enable unicode characters and repeating keyboard events
			create keyboard.make_snapshot
			keyboard.enable_unicode_characters
			keyboard.enable_repeating_key_down_events (200, 100)

			set_window_title ("EiffelMedia Vision2 Widget Example Project")
			set_window_icon ("icon.png")
			set_application_id ("vision2_example")

			-- set first scene to be shown
			set_scene (create {SIMPLE_SCENE}.make)
			launch

			-- disable everything we have enabled
			-- this prevent some possible memory leakes by the OS
			video_subsystem.disable
		end

feature {NONE} -- Implementation

	window_width: INTEGER is 600
			-- Window width

	window_height: INTEGER is 630
			-- Window height

	screen_resolution: INTEGER is 32
			-- Screen resolution

	fullscreen: BOOLEAN is false
			-- Fullscreen
end