indexing

	description: "[

		Deferred class for any audio file.
		
		Use filename to be able to select a specific from a list
		and/or other containers.

	]"
	date: "$Date: 2005/10/22 13:22:42 $"
	revision: "$Revision: 1.11 $"

deferred class

	EM_AUDIO

inherit

	EWG_STRUCT
		export
			{NONE} all
			{EM_AUDIO, EM_AUDIO_FACTORY} item
		end

	SDL_AUDIO_CVT_STRUCT_EXTERNAL
		export {NONE} all end

	SDL_AUDIO_SPEC_STRUCT_EXTERNAL
		export {NONE} all
		undefine sizeof_external end

feature {NONE} -- Initialization

	make_from_pointer (a_pointer: POINTER) is
			-- Make from `a_pointer' that is possibly shared within the
			-- process of the current OS.
		require
			a_pointer_not_void: a_pointer /= default_pointer
		do
			make_shared (a_pointer)
		end

feature {NONE} -- Internal variables

	internal_filename: STRING
			-- Internal filename

feature -- Access

	sizeof: INTEGER is
			-- Size of object
		do
			Result := sizeof_external
		end

	filename: STRING is
			-- Filename for audio chunk
		do
			if internal_filename /= Void then
				create Result.make_from_string (internal_filename)
			else
				create Result.make_empty
			end
		end

feature -- Element change

	set_filename (a_filename: like internal_filename) is
			-- Set `internal_filename' to `a_filename'.
		require
			a_filename /= Void
		do
			internal_filename := a_filename
		ensure
			filename_set: internal_filename = a_filename
		end

feature -- Conversion

	to_pointer: POINTER is
			-- Returns pointer to audio chunk
		do
			Result := item
		ensure
			Result_assigned: Result = item
		end

end