indexing

	description: "[

		Implements a sound file.
		
		This file can be either WAVE, AIFF, RIFF, OGG or VOC.

	]"
	date: "$Date: 2005/10/22 13:22:42 $"
	revision: "$Revision: 1.10 $"

class EM_SOUND

inherit

	EM_AUDIO

	EM_AUDIO_CONSTANTS
		export
			{NONE}	all
			{ANY}	Em_max_volume
		end

	SDL_MIXER_FUNCTIONS
		export {NONE} all end

	MEMORY
		export {NONE} all
		redefine dispose end

create

	{EM_AUDIO_FACTORY} make_from_pointer

feature -- Removal

	dispose is
			-- Free up resources.
		do
			mix_free_chunk_external (item)

			Precursor {MEMORY}
		end

feature -- Setters

	set_volume (a_volume: INTEGER) is
			-- Set chunk volume to `a_volume'.
			--
			-- Note: This is not the channel volume.
		require
			volume_in_range: 0 <= a_volume and a_volume <= Em_max_volume
		local
			i: INTEGER
		do
			i := mix_volume_chunk_external (item, a_volume)
		end

end