indexing

	description: "[

		Singleton representing the timer subsystem.
		Use EM_SHARED_SUBSYSTEMS to access this class.

	]"
	date: "$Date: 2005/10/23 08:56:58 $"
	revision: "$Revision: 1.7 $"

class EM_TIMER_SUBSYSTEM

inherit

	EM_SUBSYSTEM

	EM_CONSTANTS
		export {NONE} all end

	EM_TIME_SINGLETON
		export {NONE} all end

	SDL_FUNCTIONS_EXTERNAL
		export {NONE} all end

create {EM_SHARED_SUBSYSTEMS}

	make

feature {NONE} -- Initialisation

	make is
			-- Initialise subsystem whitout enabling it.
		do
		ensure
			not_enabled: not is_enabled
		end

feature -- Status report

	is_enabled: BOOLEAN is
			-- Is timer subsystem enabled?
		do
			Result := 0 /= sdl_was_init_external (Em_init_timer)
		end

feature -- Subsystem management

	enable is
			-- Enable EiffelMedia timer subsystem.
		local
			i: INTEGER
			tmp: ANY
		do
			i := sdl_init_external (Em_init_timer)
			if i >= 0 then
				-- Initialize singleton
				tmp := time
			end
		end

	disable is
			-- Disable EiffelMedia timer subsystem.
		do
			sdl_quit_sub_system_external (Em_init_timer)
		end

end