indexing

	description: "[

		An EM_SCENE that houses EM_GOOF_PHYSICS, displays and loades it from xml file.

	]"
	date: "$Date: 2005/10/23 09:37:18 $"
	revision: "$Revision: 1.7 $"

class EM_GOOF_LEVEL_SCENE

inherit

	EM_DRAWABLE_SCENE
	redefine
		redraw,
		handle_key_down_event
	end

create

	make

feature {NONE} -- Properties

	last_process: TIME
		-- Last processing time

feature {NONE} -- Drawing

	draw_all is
			-- Draw background, all inactive and the current active item to screen
		do
		end

	redraw is
			-- Redraw
		local
			now: TIME
		do
			Precursor
			create now.make_now
			physic.process(now.relative_duration(last_process).fractional_second)
			create last_process.make_now
		end

feature -- Properties

	physic: EM_GOOF_PHYSICS
		-- Level physics

feature {NONE} -- Properties

	loader: EM_GOOF_LOADER_LEVEL_FILE
		-- Level loader

feature {NONE} -- Initialization

	make(level_file: STRING) is
			-- Initialize `Current'.
		do
			make_scene

			create loader.make_from_file(level_file)
			physic := loader.goof_level
			main_container.extend(physic)
			create last_process.make_now
		end

feature -- Event Handlers

	handle_key_down_event (a_keyboard_event: EM_KEYBOARD_EVENT) is
			-- Handle key down event.
		do
			if a_keyboard_event.key = a_keyboard_event.sdlk_escape then
				event_loop.stop
			end
		end

end