indexing

	description: "[
		
		*** Since Eiffel doesn't correctly support threats, this doesn't work yet ***

		A condition variable that can be used to let threads wait for each
		other.

	]"
	date: "$Date: 2005/10/26 12:19:15 $"
	revision: "$Revision: 1.4 $"

class EM_CONDITION_VAR

inherit

	SDL_MUTEX_FUNCTIONS_EXTERNAL
	export
		{NONE} all
	end

create

	make

feature {NONE} -- Creation

	make is
			-- Creates a new condition variable.
		do
			p := sdl_create_cond_external
		end

feature -- Commands

	wait(a_mutex : EM_MUTEX) is
			-- Wait on the condition variable and unlocks `a_mutex'.
			-- The mutex must be locked before calling this feature.
			-- The mutex is needed to prevent raceconditions between
			-- a wait and a signal operation.
		require
			mutex_not_void : a_mutex /= Void
		local
			error_code : INTEGER
		do
			error_code := sdl_cond_wait_external (p, a_mutex.p)
			if error_code = -1 then
				print("Error waiting on the condition variable.")
			end
		end

	wait_with_timeout(a_mutex : EM_MUTEX; a_timeout : INTEGER) : BOOLEAN is
			-- Wait on the condition variable for at most `a_timeout' milliseconds.
			-- Returns True if the condition variable was signaled.
			-- Returns False if a timeout or an error occured.
		require
			mutex_not_void : a_mutex /= Void
		local
			error_code : INTEGER
		do
			error_code := sdl_cond_wait_timeout_external (p, a_mutex.p, a_timeout)
			if error_code = -1 then
				print("Error waiting on the condition variable.")
			end
			Result := error_code = 0
		end

	signal is
			-- Restarts one of the threads that are waiting on the condition variable.
		local
			error_code : INTEGER
		do
			error_code := sdl_cond_signal_external (p)
			if error_code = -1 then
				print("Error signaling the condition variable.")
			end
		end

	broadcast is
			-- Restarts all threads that are waiting on the condition variable.
		local
			error_code : INTEGER
		do
			error_code := sdl_cond_broadcast_external (p)
			if error_code = -1 then
				print("Error broadcasting the condition variable.")
			end
		end

feature {NONE} -- Implementation

	p : POINTER
			-- Pointer to the external C condition variable.

end