indexing

	description: "[

		Generate an HTML File for a list of all classes in the context.

	]"
	date: "$Date$"
	revision: "$Revision$"

class EDOC_CLASSES_HTML_FILE

inherit

	EDOC_HTML_OUTPUT_FILE

create

	make_file

feature {NONE} -- Initialisation

	make_file is
			-- Initalise default values
		do
			make ("classes.html")
		end

feature -- Basic operations

	generate_file is
			-- Generate classes-list file.
		local
			a_class: ET_CLASS
			a_class_cursor: DS_LIST_CURSOR [ET_CLASS]
			a_line: STRING
		do
			open_write

			put_string ("<?xml version=%"1.0%" encoding=%"ISO-8859-1%"?>%N")
			put_string ("<!DOCTYPE html PUBLIC %"-//W3C//DTD XHTML 1.1//EN%" %"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd%">%N")
			start_tag_attributes ("html", << ["xmlns", "http://www.w3.org/1999/xhtml"] >>)
			start_tag ("head")
				tag_content ("title", "Classes ("+context.short_documentation_title+")")
				tag_attributes ("link", << ["rel", "stylesheet"], ["type", "text/css"], ["href", context.relative_output_directory+"style.css"] >>)
			end_tag
			start_tag ("body")

				print_header_start
				print_classes_buttons
				print_header_end

				tag_content ("h1", "Classes")

				tag ("hr")
				start_tag_css ("ul", css_index_list)

				a_class_cursor := context.classes.new_cursor
				from
					a_class_cursor.start
				until
					a_class_cursor.after
				loop
					a_class := a_class_cursor.item
					start_tag ("li")
					a_line := print_class_name_to_string (a_class)
					a_line.append_string (tag_css_content_to_string ("span", css_index_small, " - Class in "+print_qualified_cluster_name_to_string (a_class.cluster, True)))
					content_line (a_line)
					end_tag
					a_class_cursor.forth
				end
				end_tag

				print_footer_start
				print_classes_buttons
				print_footer_end

			end_tag
			end_tag

			close
		end

end