indexing

	description: "[

		Shared access to the error handler, context and comparator objects.

	]"
	date: "$Date$"
	revision: "$Revision$"

class EDOC_SHARED_CONTEXT

feature -- Access

	Error_handler: ET_ERROR_HANDLER is
			-- Shared error handler
		once
			create Result.make_standard
		ensure
			result_exists: Result /= Void
		end

	context: EDOC_CONTEXT is
			-- Shared universe
		once
			create Result.make
		ensure
			result_exists: Result /= Void
		end

	cluster_comparator: CLUSTER_COMPARATOR is
			-- Shared class comparator
		once
			create Result
		ensure
			result_exists: Result /= Void
		end

	cluster_sorter: DS_QUICK_SORTER [ET_CLUSTER] is
			-- Shared class sorter
		once
			create Result.make (cluster_comparator)
		ensure
			result_exists: Result /= Void
		end

	class_comparator: CLASS_COMPARATOR is
			-- Shared class comparator
		once
			create Result
		ensure
			result_exists: Result /= Void
		end

	class_sorter: DS_QUICK_SORTER [ET_CLASS] is
			-- Shared class sorter
		once
			create Result.make (class_comparator)
		ensure
			result_exists: Result /= Void
		end

end